// *****************************************************************
// *                                                               *
// *       Copyright (c) Fast Corporation, 2002                    *
// *                                                               *
// *   All Rights Reserved.  Unpublished rights  reserved  under   *
// *   the copyright laws of the Japan.                            *
// *                                                               *
// *   The software contained on this media  is  proprietary  to   *
// *   and  embodies  the  confidential  technology  of  Fast      *
// *   Corporation.  Possession, use,  duplication  or             *
// *   dissemination of the software and media is authorized only  *
// *   pursuant to a valid written license from Fast Corporation.  *
// *                                                               *
// *****************************************************************
//
// -------------------------------------------------------------------
// FVX Sample Program
// C_CAO
//
// 쐬 : K.Yakushinji
//
//  : 2006/03/29 
//
// -------------------------------------------------------------------

//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "LicenceForm.h"
#include "ConfFileForm.h"
#include "RotateForm.h"
#include "ShiftForm.h"
#include "MainForm.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "FVXCOMDISPLAYEXLib_OCX"
#pragma link "FVXCOMAFFINELib_OCX"
#pragma link "FVXCOMFILEACCESSLib_OCX"
#pragma link "FVXCOMIMAGELib_OCX"
#pragma link "FVXCOMROILib_OCX"
#pragma link "FVXCOMVIDEOLib_OCX"
#pragma resource "*.dfm"
TfrmMain *frmMain;
//---------------------------------------------------------------------------
__fastcall TfrmMain::TfrmMain(TComponent* Owner)
        : TForm(Owner)
{
}

//---------------------------------------------------------------------------
// 摜t@Cǂݍ
void __fastcall TfrmMain::btnLoadImageClick(TObject *Sender)
{

        OpenDialog1->InitialDir = ExtractFilePath(Application->ExeName);
        OpenDialog1->Filter = "bitmap file(*.bmp)|*.bmp";
        if (OpenDialog1->Execute())
        {
                FvxFileAccess1->FilePath = OpenDialog1->FileName;

                try
                {
                        FvxFileAccess1->LoadBitmap( FvxImage1->ControlInterface );
                }
                catch (long &err)
                {
                        AnsiString errMsg;
                        errMsg.sprintf("Ǎ݂Ɏs܂BErrCode= %ld",err);
                        ShowMessage(errMsg);
                        return;

                }

	        // 摜`FbN
        	if (( FvxImage1->BitPerPixel!=8 ) || ( FvxImage1->ImageType!=imageGray ))
                {
                        ShowMessage("8bitO[摜ł͂܂");
                        FvxImage1->BitPerPixel = 8;
                        FvxImage1->ImageType = imageGray;
                        FvxImage1->ImageWidth = 512;
                        FvxImage1->ImageHeight = 480;
		}

	        FvxDisplayEx1->DrawImage(FvxImage1->ControlInterface);
        }

}
//---------------------------------------------------------------------------

//  摜t@Cۑ
void __fastcall TfrmMain::btnSaveImageClick(TObject *Sender)
{

        SaveDialog1->InitialDir = ExtractFilePath(Application->ExeName);
        SaveDialog1->DefaultExt = "bmp";
        SaveDialog1->Filter = "bitmap file(*.bmp)|*.bmp";
        if (SaveDialog1->Execute())
        {
                FvxFileAccess1->FilePath = SaveDialog1->FileName;

                try
                {
                        FvxFileAccess1->SaveBitmap( FvxImage1->ControlInterface );
                }
                catch (long &err)
                {
                        AnsiString errMsg;
                        errMsg.sprintf("ۑɎs܂BErrCode= %ld",err);
                        ShowMessage(errMsg);
                        return;

                }
        }
}
//---------------------------------------------------------------------------

//  2{g
void __fastcall TfrmMain::btnEnlargeClick(TObject *Sender)
{

        TFvPoint* pPos = new TFvPoint( NULL );

        // \̎n_͍ɐݒ
        pPos->set_x(0);
        pPos->set_y(0);

        // 2{Ɋg
        FvxAffine1->Magnification( FvxImage1->ControlInterface , FvxImage2->ControlInterface , 2 , 2 , pPos->GetDefaultInterface());

        FvxImage2->CopyTo( FvxImage1->ControlInterface );
        FvxDisplayEx1->DrawImage( FvxImage1->ControlInterface );

        delete pPos;
}
//---------------------------------------------------------------------------

//  1/2{k
void __fastcall TfrmMain::btnReductionClick(TObject *Sender)
{

        TFvPoint* pPos = new TFvPoint( NULL );

	// 
	pPos->set_x( 0 );
	pPos->set_y( 0 );
	FvxAffine1->Magnification( FvxImage1->ControlInterface , FvxImage2->ControlInterface , 0.5 , 0.5 , pPos->GetDefaultInterface());

	// E
	pPos->set_x(( FvxImage1->ImageWidth / 2));
	pPos->set_y( 0 );
	FvxAffine1->Magnification( FvxImage1->ControlInterface , FvxImage2->ControlInterface , 0.5 , 0.5 , pPos->GetDefaultInterface());

	// 
	pPos->set_x( 0 );
	pPos->set_y(( FvxImage1->ImageHeight / 2));
	FvxAffine1->Magnification( FvxImage1->ControlInterface , FvxImage2->ControlInterface , 0.5 , 0.5 , pPos->GetDefaultInterface());

	// E
	pPos->set_x(( FvxImage1->ImageWidth / 2));
	pPos->set_y(( FvxImage1->ImageHeight / 2));
	FvxAffine1->Magnification( FvxImage1->ControlInterface , FvxImage2->ControlInterface , 0.5 , 0.5 , pPos->GetDefaultInterface());

	FvxImage2->CopyTo( FvxImage1->ControlInterface );
	FvxDisplayEx1->DrawImage( FvxImage1->ControlInterface );

        delete pPos;

}
//---------------------------------------------------------------------------

// ̈w肵Ċg
void __fastcall TfrmMain::btnAreaEnlargeClick(TObject *Sender)
{

        double  dblScaleX=0;     //Xg{
        double  dblScaleY=0;     //Yg{
        double  dblTemp=0;
        long    lngOK=0;

        // f[^^m
        TFvRectangle* pRect = new TFvRectangle(NULL);
	TFvPoint* pPos = new TFvPoint(NULL);
	TFvMovement* pMove = new TFvMovement(NULL);

        // ͈͑ȈlKɐݒ
        pRect->set_xs( 100 );
        pRect->set_ys( 100 );
        pRect->set_xe( 200 );
        pRect->set_ye( 200 );
        FvxROI1->SetRectangle( pRect->GetDefaultInterface() );

        // FvxROIgď͈͑I_CAOo܂
	FvxROI1->UsePoint = FALSE;
	FvxROI1->MakeROIDialog( FvxImage1->ControlInterface, &lngOK );

        if ( (lngOK == 1) && (FvxROI1->CheckRectangle == 1)) {

                FvxROI1->GetRectangle( pRect->GetDefaultInterface() );

	        // n_ƏI_tɂȂĂȂ`FbN܂
                // FvxROI͋`f[^ŁAEE̍WʒutɂȂĂꍇ(xs > xe, ys > ye)łA
                // ւ̂܂܌ʂԂ܂̂ŁAӂĂ
                if ( pRect->get_xe() < pRect->get_xs() ) {
                    dblTemp = pRect->get_xs();
                    pRect->set_xs( pRect->get_xe() );
                    pRect->set_xe( dblTemp );
	                }
		if ( pRect->get_ye() < pRect->get_ys() ) {
                    dblTemp = pRect->get_ys();
                    pRect->set_ys( pRect->get_ye() );
                    pRect->set_ye( dblTemp ) ;
	        }

		// g̔{vZ
		dblScaleX = FvxImage1->ImageWidth / ( pRect->get_xe() - pRect->get_xs() );
		dblScaleY = FvxImage1->ImageHeight / ( pRect->get_ye() - pRect->get_ys() );

                // g̈̍オW(0,0)ɂ悤ɕsړ
                pMove->set_x( pRect->get_xs() );
                pMove->set_y( pRect->get_ys() );
                FvxAffine1->Shift( FvxImage1->ControlInterface, FvxImage2->ControlInterface, pMove->GetDefaultInterface());

                // \̎n_͍
                pPos->set_x( 0 );
                pPos->set_y( 0 );
                FvxAffine1->Magnification( FvxImage2->ControlInterface, FvxImage1->ControlInterface, dblScaleX, dblScaleY, pPos->GetDefaultInterface());
		FvxDisplayEx1->DrawImage( FvxImage1->ControlInterface );
	}

        // J
        delete pRect;
        delete pPos;
        delete pMove;


}
//---------------------------------------------------------------------------

// ʂ̏
void __fastcall TfrmMain::FormShow(TObject *Sender)
{

        // i[pϐ
        AnsiString str;

        // ϐ
  	m_blnVideoOpened = false;
        btnGrab->Enabled = false;

        //ʂ̐
	FvxDisplayEx1->CreateDisplay(1,0);

	//gp̊mF
        frmLicence->ShowModal();
	if ( frmLicence->blnIsAccepted )
	{

                //rfIݒt@C̑I
                frmConfFile->ShowModal();

                if ( frmConfFile->bOK ) str =frmConfFile->strVideoConfFilePath;

               	if  ( str.Length() > 0 )
                {

                        //rfIݒt@CR|[lgɐݒ
                        FvxVideo1->VideoConfFile = str;
                        //foCXI[v
                        try
		        {
			       	FvxVideo1->OpenDevice();
        		}
                        catch( long &err )
		        {
                                str.printf("rfIfoCX̃I[vɎs܂BErrCode= %ld \r\n摜t@Ĉ݂̗pɂȂ܂B",err);
                                ShowMessage(str);
        			return;
	        	}
                        //VideoConfFile̕ύXAOpenDevicesƁAgK[[h̕ύX܂
        		//̂߁AЃLv`{[hFVC02ł350ms̃ZbgAbv^CKvɂȂ܂
	        	//{vOł͊ȗ̂߂ɁAꗥ350ms̃ZbgAbv^CmۂĂ܂A
		        //g̃Lv`{[hɍ킹ĕύXĂB
			Sleep(350);

        		//GrabSync/GrabASync\bhłImegeTCY̕ύXs܂̂ŁA
	        	//炩ChangeImageSize\bhɂImagẽTCYύXĂ
		        //i荞݃TCYImagẽTCYႤꍇG[ɂȂ܂j
			FvxVideo1->ChangeImageSize(FvxImage1->ControlInterface);
        		try
	        	{
		                // 捞
			        FvxVideo1->GrabSync(FvxImage1->ControlInterface);
                        }
	        	catch (long &err)
		        {
                                str.printf("rfI̎捞Ɏs܂ErrCode= %ld \r\n摜t@Ĉ݂̗pɂȂ܂B",err);
                                ShowMessage(str);
        			return;
	        	}

		        //rfIfoCX̏Ԃۑ
			m_blnVideoOpened = true;
        		btnGrab->Enabled = true;
                        //摜\
		        FvxDisplayEx1->DrawImage(FvxImage1->ControlInterface);
                }
        }
	else
	{
		// I
		Application->Terminate();
		return;
	}


}
//---------------------------------------------------------------------------



// sړ
void __fastcall TfrmMain::btnShiftClick(TObject *Sender)
{
        frmShift->bOK = false;
        frmShift->ShowModal();
	if ( frmShift->bOK )
        {
                TFvMovement *pMovement = new TFvMovement(NULL);
                pMovement->set_x(StrToFloat(frmShift->edit1->Text));
                pMovement->set_y(StrToFloat(frmShift->edit2->Text));
                FvxAffine1->Shift(FvxImage1->ControlInterface, FvxImage2->ControlInterface, pMovement->GetDefaultInterface());
                FvxImage2->CopyTo(FvxImage1->ControlInterface);
                FvxDisplayEx1->DrawImage(FvxImage1->ControlInterface);
                delete pMovement;
        }

}
//---------------------------------------------------------------------------


// ]
void __fastcall TfrmMain::btnRotateClick(TObject *Sender)
{
        frmRotate->bOK = false;
        frmRotate->ShowModal();
	if ( frmRotate->bOK )
        {

		// 摜̒S]SƂ
                TFvPoint *pPoint = new TFvPoint(NULL);
                pPoint->set_x( FvxImage1->ImageWidth / 2 );
		pPoint->set_y( FvxImage1->ImageHeight / 2 );
                double dAngle = StrToFloat(frmRotate->edit1->Text);
                FvxAffine1->Rotation( FvxImage1->ControlInterface, FvxImage2->ControlInterface, dAngle ,pPoint->GetDefaultInterface());
                FvxImage2->CopyTo(FvxImage1->ControlInterface);
                FvxDisplayEx1->DrawImage(FvxImage1->ControlInterface);
                delete pPoint;
        }

}
//---------------------------------------------------------------------------

// EBhETCYύXꂽƂ̏
void __fastcall TfrmMain::FormResize(TObject *Sender)
{
        FvxDisplayEx1->Width = this->Width - 165;
        FvxDisplayEx1->Height = this->Height - 60;

}
//---------------------------------------------------------------------------

// EBhEjꂽƂ̏
void __fastcall TfrmMain::FormDestroy(TObject *Sender)
{
        // rfIfoCXI[vĂꍇ̓N[Y܂
        if ( m_blnVideoOpened )	FvxVideo1->CloseDevice();
}
//---------------------------------------------------------------------------

// J捞

void __fastcall TfrmMain::btnGrabClick(TObject *Sender)
{
        //摜t@Cǂݍ݂ɂāA摜TCY
	//ύXĂ\邽߁AChangeImageSizes܂B
	//摜TCYύX\ꍇ́AɈxsΖL܂B
	FvxVideo1->ChangeImageSize(FvxImage1->ControlInterface);
        try
	{
		//捞
		FvxVideo1->GrabSync(FvxImage1->ControlInterface);
	}
	catch (long &err)
	{
                // i[pϐ
                AnsiString str;
                str.printf("rfI̎捞Ɏs܂ErrCode= %ld ",err);
                ShowMessage(str);
	}

        //摜\
        FvxDisplayEx1->DrawImage(FvxImage1->ControlInterface);
        
}
//---------------------------------------------------------------------------

